<script lang="ts">
import Vue from 'vue';

import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';

import { Modal as SlpModal } from '~/components/common/index.vue';

export default Vue.extend({
  name: 'EGroup',
  components: {
    SlpModal,
  },
  async asyncData({ $content }) {
    const doc = await $content('company/team/e-group').fetch();
    return { doc };
  },
  nuxtI18n: false,
  data() {
    return {
      isModalOpen: false,
      modalInfo: {},
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).doc, this.$route.path);
  },
  methods: {
    openModal(info: Object) {
      this.isModalOpen = true;
      this.modalInfo = info;
    },
    closeModal() {
      this.isModalOpen = false;
    },
  },
});
</script>

<template>
  <section class="background-purple">
    <SlpContainer class="e-group">
      <div class="e-group__gradient-header slp-mt-48" />
      <SlpRow class="slp-mb-md-96 slp-mb-48">
        <SlpTypography tag="h2" variant="heading2-bold">
          {{ doc.main_content_block.header }}
        </SlpTypography>
      </SlpRow>
      <SlpRow>
        <SlpColumn
          v-for="headshot in doc.main_content_block.headshots"
          :key="headshot.name"
          class="slp-mb-64 e-group__wrapper"
          :cols="6"
          size="lg"
        >
          <div class="e-group__headshot" @click="openModal(headshot)">
            <nuxt-img
              class="e-group__headshot__image"
              :src="headshot.picture.url"
              :alt="headshot.picture.alt"
            />
            <div class="e-group__headshot-body">
              <SlpTypography class="slp-mb-32" tag="h4" variant="heading4-bold">
                {{ headshot.name }}
              </SlpTypography>
              <SlpTypography tag="p" variant="body1">
                {{ headshot.title }}
              </SlpTypography>
              <SlpButton
                class="slp-mt-24"
                variant="tertiary"
                data-ga-location="body"
                :data-ga-name="headshot.name"
                @click="openModal(headshot)"
              >
                Learn more
                <SlpIcon name="chevron-lg-right" variant="product" />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
      <SlpRow
        v-for="(link, i) in doc.main_content_block.view_more_links"
        :key="i"
        class="e-group__more-links"
      >
        <SlpButton
          :data-ga-location="link.data_ga_location"
          :data-ga-name="link.data_ga_name"
          :href="link.url"
          class="slp-my-48"
          variant="tertiary"
        >
          {{ link.text }}
          <SlpIcon name="chevron-lg-right" variant="product" />
        </SlpButton>
      </SlpRow>
      <SlpModal v-if="isModalOpen" class="e-group__modal" @close="closeModal">
        <div class="e-group__modal-content">
          <SlpTypography tag="h3" variant="heading3-bold">
            {{ modalInfo.name }}
          </SlpTypography>
          <SlpTypography tag="p" variant="body1-bold">
            {{ modalInfo.location }}
          </SlpTypography>
          <div
            class="e-group__modal-story"
            v-html="$md.render(modalInfo.story)"
          ></div>
        </div>
      </SlpModal>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.background-purple {
  background-color: $color-surface-800;
}

.e-group {
  &__wrapper {
    flex: 1;
  }

  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
    margin-bottom: $spacing-16;
  }

  &__headshot {
    height: 100%;
    background: $color-primary-300;
    border-radius: 20px;
    display: flex;
    flex-direction: column;
    position: relative;

    @media (min-width: $breakpoint-md) {
      &:nth-child(even) {
        margin-left: $spacing-48;
      }

      &:nth-child(odd) {
        margin-right: $spacing-48;
      }
    }

    &__image {
      object-fit: cover;
      max-height: 240px;
      height: 240px;

      @media (min-width: $breakpoint-md) {
        position: absolute;
        top: -32px;
        left: -20px;
        max-width: 220px;
        width: 220px;
        border-bottom-right-radius: 100px;
      }
    }

    &:hover {
      cursor: pointer;
    }
  }

  &__headshot-body {
    padding: $spacing-32;
    min-height: 250px;

    @media (min-width: $breakpoint-md) {
      padding-left: 250px;
    }
  }

  &__more-links {
    justify-content: center;
  }

  &__modal-story &:deep p {
    padding-top: 20px;
  }

  &__modal-content {
    max-width: 800px;
    padding: 32px;

    &:deep p {
      padding-top: 20px;
    }

    @media (max-width: $breakpoint-md) {
      max-height: 90vh;
      overflow-y: auto;
    }
  }
}
</style>
